
# o[W3.4.4

rm(list=ls(all=T))   #ϐ
gc(); gc()           #ʂ̓K

#--------------------------------------------------------------------
#    RevoUtilsMath pbP[W̃CXg[
#install.packages("RevoUtilsMath")
#library(RevoUtilsMath)

#--------------------------------------------------------------------
#install.packages("RevoUtilsMath")
#install.packages("MASS")
#install.packages("stringr")
#install.packages("grid") #gridǂݍ
#install.packages("resyape2")
#install.packages("data.table")
#install.packages("plyr")
install.packages("dplyr")
install.packages("dtplyr")
install.packages("tidyr")
#install.packages("bit64")
#install.packages("foreach")
#install.packages("doParallel")
#install.packages("compiler")
#install.packages("RPostgreSQL")
#install.packages("lubridate")
#install.packages("ggplot2")
#install.packages("maptools")
#install.packages("rgdal")
#install.packages("splancs")
#install.packages("scales")
#install.packages("spdep")
#install.packages("maptools")
#install.packages("ggmaps")
#install.packages("ggmap")
#install.packages("spsurvey")
#install.packages("RColorBrewer")
#install.packages("sp")
#install.packages("tbl_dt")
install.packages("sf")
#--------------------------------------------------------------------


library(MASS)
library(stringr)
library(grid) #gridǂݍ
#library(resyape2)

library(data.table)
library(plyr)
library(dplyr)
library(dtplyr)
library(tidyr)
library(bit64)
library(foreach)
library(doParallel)
library(compiler)
library(RPostgreSQL)
library(lubridate)
library(ggplot2)
library(maptools)
library(rgdal)
library(splancs)
library(scales)
library(spdep)
library(maptools)
library(ggmap)
library(ggmaps)
library(spsurvey)
library(RColorBrewer)
library(sp)
#install.packages("Matching")
library(Matching)
library(tbl_dt)
library(sf)

#--------------------------------------------------------------------
#       pX̐ݒ
#--------------------------------------------------------------------
#

#--------------------------------------------------------------------
#       f[^̎荞
#--------------------------------------------------------------------
#getwd()
#f[^i[tH_
setwd("E:/sfĂ̊wZi2019j")
getwd()
(wd <- getwd())

#f[^̓ǂݍ

load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_tokyo.RData", sep=""))
load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_sinagawa.RData", sep=""))
load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_akiba.RData", sep=""))
load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_sinzyuku.RData", sep=""))
load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_ueno.RData", sep=""))
load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_sinbashi.RData", sep=""))
load(file=paste(wd, "/R_output/NI_iN2km_I1kmj/toyosu_kasumigaseki.RData", sep=""))

# ej^[̔N
merged<-read.csv("Rpf[^/merged.csv",fileEncoding = "UTF-8") 
age <- subset(merged,select=c(gbvID,N,N_~[)) %>% 
 group_by(gbvID,N,N_~[) %>% 
  summarize(count = n()) 

# egbv̍GwW
GwW<-read.csv("Rpf[^/GwW.csv") 


GwW <- GwW %>% filter(GwW!="#VALUE!")
GwW <- subset(GwW,select=c(gbvID,GwW)) %>% 
  group_by(gbvID,GwW) %>% 
  summarize(count = n())

# egbṽRXg
cost<-read.csv("Rpf[^/cost.csv",fileEncoding = "UTF-8") 
# gbvƂ̃O[v
cost <- subset(cost, select=c(gbvID,ԃRXg,oXRXg,SRXg)) %>% 
  group_by(gbvID,ԃRXg,oXRXg,SRXg) %>% 
  summarize(count = n()) 

# v
time<-read.csv("R_output/toyosu_city_judg_2.csv") 
time <- subset(time,select=c(gbvID,gbv_b_car,gbv_b_train,
                                      gbv_b_bus)) %>% 
  group_by(gbvID,gbv_b_car,gbv_b_train,
               gbv_b_bus) %>% 
  summarize(count = n()) 

# 
dist <- read.csv("R_output/toyosu_dist.csv")
dist <- subset(dist, select=c(tripID,dist))
colnames(dist) <- c("gbvID","dist")

G <- read.csv("R_output/toyosu_city_judg_2.csv")
G <- subset(G,select=c(gbvID,G)) %>% 
  group_by(gbvID,G) %>% 
  summarize(count = n())



# en_ɂ܂Ƃ߂icɘAj
toyosu_city <- rbind(toyosu_tokyo_model,
                     toyosu_sinagawa_model,
                     toyosu_akiba_model,
                     toyosu_sinzyuku_model,
                     toyosu_ueno_model,
                     toyosu_sinbashi_model,
                     toyosu_kasumigaseki_model)

rm(toyosu_tokyo_model)
rm(toyosu_sinagawa_model)
rm(toyosu_akiba_model)
rm(toyosu_sinzyuku_model)
rm(toyosu_ueno_model)
rm(toyosu_sinbashi_model)
rm(toyosukasumigaseki_model)



# k̃gbv̏
toyosu_city <- toyosu_city %>% filter(ړi!="k")

# ړiinSƓSuSvɕϊj
toyosu_city_judg <- toyosu_city %>% 
  dplyr::mutate(
    judg = case_when(
      ړi == "nS" ~"S",
      ړi == "S" ~"S",
      ړi == "p" ~"p",
      ړi == "oX" ~"oX"
    @))

#write.csv(toyosu_city_judg,"R_output/NI_iN2km_I1kmj/toyosu_city.csv",row.names=F)



#--------------------------------------------------------------------
#      ϐ̒ǉ
#--------------------------------------------------------------------
# N_~[̒ǉ
toyosu_city_judg_1 <- dplyr::inner_join(toyosu_city_judg,age,by="gbvID") 
# GwW
toyosu_city_judg_2 <- dplyr::full_join(toyosu_city_judg_1,GwW,by="gbvID") 
# cost
toyosu_city_judg_3 <- dplyr::inner_join(toyosu_city_judg_2,cost,by="gbvID") 
# v
toyosu_city_judg_4 <- dplyr::inner_join(toyosu_city_judg_3,time,by="gbvID") 
# 
toyosu_city_judg_5 <- dplyr::inner_join(toyosu_city_judg_4,dist,by="gbvID") 
# G
toyosu_city_judg_6 <- dplyr::inner_join(toyosu_city_judg_5,G,by="gbvID") 




toyosu_city_judg_7 <- subset(toyosu_city_judg_6,select=c(gbvID,judg,gbv_b_car,gbv_b_train,
                                                             gbv_b_bus,ԃRXg,oXRXg,SRXg,
                                                             N_~[,N,dist,dist.y,G)) %>% 
  group_by(gbvID,judg,gbv_b_car,gbv_b_train,
               gbv_b_bus,ԃRXg,oXRXg,SRXg,
               N_~[,N,dist,dist.y,G) %>% 
  summarize(count = n())
# dataւ̊i[
data<-toyosu_city_judg_7

write.csv(data,"R_output/data_1.csv",row.names=F)
data<-read.csv("R_output/data_1.csv") 


#f[^̍s𐔂iKsj
hh<-nrow(data)


#--------------------------------------------------------------------
#       p[^̏l̐ݒ
#--------------------------------------------------------------------
#p[^̏l̐ݒ
b0<-numeric(6)

#--------------------------------------------------------------------
#       p[^̐錾
#--------------------------------------------------------------------
#@Logit model̑ΐޓx֐̒`
fr<-function(x) {
  # p[^̐錾
  # 萔
  b1<-x[1]
  b2<-x[2]
  # ړIn܂ł̏v
  d1<-x[3]
  # N
  a1<-x[4]
  
  d2<-x[5]
@# GwW
  c1<-x[6]
  # 
  #f1<-x[7] 
  # ΐޓx̂߂̕ϐ錾
  LL=0 
  
  
#--------------------------------------------------------------------
#       pV̌vZ
#--------------------------------------------------------------------
  #@pړIn͈ȉ5
  #@Sitrainj
  #@oXibusj
  #@pԁicarj

  
  #@p̌vZFϐ̂
  train <- exp(d1*data$gbv_b_train +c1*data$G   +d2*data$dist.y +b1*matrix(1,nrow =hh,ncol=1))
  bus   <- exp(d1*data$gbv_b_bus                    +b2*matrix(1,nrow =hh,ncol=1))
  car   <- exp(d1*data$gbv_b_car  +a1*data$N) 
  #--------------------------------------------------------------------
  #       ʎiɂđWbgf
  #--------------------------------------------------------------------
  #@Im̌vZ
  #@ƂȂAeXexp(V)̘a
  deno<-(car+train+bus)
  
  # ꂼvZ
  Ptrain<-(train/deno)
  Pbus  <-(bus/deno)
  Pcar  <-(car/deno)
  
  
  #--------------------------------------------------------------------
  #       Im̕␳
  #--------------------------------------------------------------------
  #@Im0ɂȂĂ܂ꍇɋN̉
  Ptrain <-(Ptrain!=0) *Ptrain +(Ptrain==0)
  Pbus   <-(Pbus!=0)   *Pbus   +(Pbus==0)
  Pcar   <-(Pcar!=0)   *Pcar   +(Pcar==0)

  #--------------------------------------------------------------------
  #       I
  #--------------------------------------------------------------------
  Ctrain <-data$judg=="S"
  Cbus   <-data$judg=="oX"
  Ccar   <-data$judg=="p"

  #--------------------------------------------------------------------
  #       ΐޓx̌vZ
  #--------------------------------------------------------------------
  LL <-colSums(Ctrain*log(Ptrain) + Cbus*log(Pbus) + 
                 Ccar*log(Pcar) )
}


#--------------------------------------------------------------------
#       ΐޓx֐̍ő剻
#--------------------------------------------------------------------
#@ΐޓx֐fr̍ő剻

#@p[^l̍œK
res<-optim(b0,fr,gr=NULL,method = "Nelder-Mead",hessian=TRUE,control=list(fnscale=-1))


#--------------------------------------------------------------------
#       p[^AwbZs̔o
#--------------------------------------------------------------------
b<-res$par
hhh<-res$hessian

#--------------------------------------------------------------------
#       tľvZ
#--------------------------------------------------------------------
tval<-b/sqrt(-diag(solve(hhh)))

#--------------------------------------------------------------------
#       ޓxAŏIޓx̎Zo
#--------------------------------------------------------------------
#@ޓx
L0<-fr(b0)
#@ŏIޓx
LL<-res$value

#--------------------------------------------------------------------
#       ʂ̕\
#--------------------------------------------------------------------
#@ʂ̏o
print(res)
#@ޓx
print(L0)
#@ŏIޓx
print(LL)
#@ρO2l
print((L0-LL)/L0)
#@CσρO2l
print((L0-(LL-length(b)))/L0)
#@p[^l
print(b)
#@tl
print(tval)



#--------------------------------------------------------------------
# Wbgfł̐vʂcsv`ŕۑ
#--------------------------------------------------------------------
#f[^t@Ci[tH_ƃtH_ɐݒ
setwd(wd)
getwd()

parameter <- b
tval <- tval
result <- cbind(parameter,tval)
result1 <- cbind("Tv", hh)
result2 <- cbind("ޓx", L0)
result3 <- cbind("ŏIޓx", LL)
result4 <- cbind("Cςݖޓx", (L0-(LL-length(b)))/L0)

filename <- paste("R_outputifj/MNLf.csv",sep="")

write.table(result,filename,append=T,quote=F,sep=",",row.names=T,col.names=F)
write.table(result1,filename,append=T,quote=F,sep=",",row.names=F,col.names=F)
write.table(result2,filename,append=T,quote=F,sep=",",row.names=F,col.names=F)
write.table(result3,filename,append=T,quote=F,sep=",",row.names=F,col.names=F)
write.table(result4,filename,append=T,quote=F,sep=",",row.names=F,col.names=F)
write.table("",filename,append=T,quote=F,sep=",",row.names=F,col.names=F)
